//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                                                           e-PSI@Multi_Scalper.mq4 |
//|                                Copyright  2012, Unga & Igor Stepovoi aka TarasBY |
//|                                                                taras_bulba@tut.by |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
#property copyright "Copyright  2008-12, TarasBY WM R418875277808; Z670270286972"
#property link      "taras_bulba@tut.by"
//IIIIIIIIIIIIIIIIIII==================CONSTANS=================IIIIIIIIIIIIIIIIIIIIII+
#define UP 0
#define DW 1
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  *****                   *****                  |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
extern string SETUP_Expert          = "==========    ==========";
extern int    MG                       = 2012;
extern int    NewBarInPeriod          = 1;                 // >= 0 -      , -1 -    
extern bool   CloseInverseSignal       = true;             //    
extern string Symbol_List              = "EURUSD,USDCHF,GBPUSD,USDJPY";
extern int    StopLoss                 = 25;
extern int    TakeProfit               = 500;
#include      <b-PSI@TradeLight.mqh>                       //    
extern string SETUP_Indicator       = "=============== Setup Indicator ===============";
extern int    TF_Indicator             = 60;               //  
/*extern*/ int    FilterPeriod             = 22;
/*extern*/ int    SL_distance_pips         = 20;
/*extern*/ int    BarControl               = 5;
/*extern*/ double LevelControl             = 0.9;
extern string Setup_Lots            = "========     ========";
extern bool   UseMM                    = TRUE;             //   
extern string Setup_LotsWayChoice_0_1  = "0-.; 1-%  MeansType;";
extern int    LotsWayChoice            = 1;                //    :
extern string Setup_MeansType_0_3      = "1-Balance; 2-Equity; 3-FreeMargin;";
extern int    MeansType                = 2;                //  ,     :
extern double Order_Lots               = 0.1;              //   
extern int    LotsPercent              = 5;                //   MeansType
extern double MinLot                   = 0.01;             //    
extern double MaxLot                   = 5.0;              //     
//IIIIIIIIIIIIIIIIIII========== ==========IIIIIIIIIIIIIIIIIIIIII+
#include      <b-PSI@ManagerPA.mqh>                        //      
//IIIIIIIIIIIIIIIIIII======  ======IIIIIIIIIIIIIIIIIIIIII+
double        gd_SL, gd_TP, gd_LOTSTEP, gd_MINLOT, gd_MAXLOT, gd_Profit;
int           gi_Decimal = 1, gi_dig, cnt_SMB, gia_MyOrders[][3], gi_MyOrders;
string        gsa_SMB[], gs_EXP_Comment = "ScalperM", gs_NameGV, gs_Error = "";
datetime      gdt_NewBar, gdt_NewBarIndicator;
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custom expert initialization function                            |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int init()
{
//----
    gi_dig = LotDecimal();
    gs_NameGV = StringConcatenate ("MSculper[", MG, "]");
    if (Digits % 2 == 1) {gi_Decimal = 10;}
    gd_SL = StopLoss * gi_Decimal;
    gd_TP = TakeProfit * gi_Decimal;
    gd_LOTSTEP = MarketInfo (Symbol(), MODE_LOTSTEP);
    gd_MINLOT = MarketInfo (Symbol(), MODE_MINLOT);
    gd_MAXLOT = MarketInfo (Symbol(), MODE_MAXLOT);
    //----  
    Order_Lots = fLotsNormalize (Order_Lots);
    //----      
    if (IsOptimization() || IsTesting())
    {Symbol_List = Symbol();}
    cnt_SMB = fSplitStrToStr (Symbol_List, gsa_SMB);
    ArrayResize (gia_MyOrders, cnt_SMB);
    //----      
    fInit_TradeLight ();
    //----      
    fInit_ManagerPA (gs_NameGV, Symbol_List, MG);
//----
    return(0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|                  Custor expert deinitialization function                          |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int deinit()
{
//----
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|               Custom expert iteration function                                    |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int start()
{
    //----    "" 
    if (fSet_Continue()) return (0);
    datetime ldt_BeginNewBarIndicator = iTime (Symbol(), TF_Indicator, 0);
    if (gdt_NewBarIndicator == ldt_BeginNewBarIndicator) {return (0);}
    if (NewBarInPeriod >= 0)
    {
        datetime ldt_BeginNewBarInPeriod = iTime (Symbol(), NewBarInPeriod, 0);
        if (gdt_NewBar == ldt_BeginNewBarInPeriod) {return (0);}
        gdt_NewBar = ldt_BeginNewBarInPeriod;
    }
    
//----
    string   ls_txt = "";
//----
    gi_MyOrders = fMyPositions (gd_Profit, gia_MyOrders, gsa_SMB, MG);
    //----        
    fManagerPA (ls_txt, Symbol_List, MG, gd_Profit, gi_MyOrders > 0, gs_Error);
    if (StringLen (ls_txt) > 0) Print (ls_txt);
    if (StringLen (gs_Error) > 0) Print (gs_Error);
    //----      
    for (int li_SMB = 0; li_SMB < cnt_SMB; li_SMB++)
    {fControl_Symbol (gsa_SMB[li_SMB], li_SMB);}
    if (gi_MyOrders == 0) gdt_NewBarIndicator = ldt_BeginNewBarInPeriod;
//----
    return (0);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY                                                                  |
//+-----------------------------------------------------------------------------------+
//|                                                         |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
string fGet_OrderComment (int fi_Type)
{return (StringConcatenate (gs_EXP_Comment, " | ", fGet_NameOP (fi_Type), " | ", gi_MyOrders + 1));}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY                                                                  |
//+-----------------------------------------------------------------------------------+
//|                                                           |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fGet_Signal (string fs_Symbol, int fi_Bar = 5)
{
    double ld_Signal_0 = iCustom (fs_Symbol, TF_Indicator, "scalping_future", FilterPeriod, SL_distance_pips, 0, 0), ld_Popravka = 0.3,
           ld_Signal_Bar = iCustom (fs_Symbol, TF_Indicator, "scalping_future", FilterPeriod, SL_distance_pips, 0, fi_Bar);
    int    li_Signal = -1;
//----
    if (ld_Signal_Bar <= -LevelControl && ld_Signal_0 > ld_Popravka - LevelControl) li_Signal = UP; //up
    if (ld_Signal_Bar >= LevelControl && ld_Signal_0 < LevelControl - ld_Popravka) li_Signal = DW;  //down
//----
    return (li_Signal);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY                                                                  |
//+-----------------------------------------------------------------------------------+
//|            (fs_Symbol)                                |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
void fControl_Symbol (string fs_Symbol, int fi_IND)
{
    int li_Signal = fGet_Signal (fs_Symbol, BarControl);
//----
    if (li_Signal < 0) return;
    if (gia_MyOrders[fi_IND][2] == 0)
    {
        int    li_Digits = MarketInfo (fs_Symbol, MODE_DIGITS), li_Ticket;
        double ld_Point = MarketInfo (fs_Symbol, MODE_POINT), ld_Price;
        RefreshRates();
        for (int li_CMD = 0; li_CMD < 2; li_CMD++)
        {
            if (li_Signal == li_CMD)
            {
                ld_Price = NormalizeDouble (fGet_TradePrice (li_CMD, bb_RealTrading, fs_Symbol), li_Digits);
                li_Ticket = fOrderSend (fs_Symbol, li_CMD, fGet_SizeLot (Order_Lots), ld_Price, Slippage, gd_SL * ld_Point, gd_TP * ld_Point, fGet_OrderComment (li_CMD), MG);
                break;
            }
        }
        if (li_Ticket > 0) gi_MyOrders++;
    }
    else
    {
        if (!CloseInverseSignal || bb_TSProfit) return;
        double ld_Pribul;
        int    li_cmd;
        for (li_CMD = 0; li_CMD < 2; li_CMD++)
        {
            if (li_CMD == 0) li_cmd = 1; else li_cmd = 0;
            if (li_Signal == li_CMD)
            {
                if (gia_MyOrders[fi_IND][li_cmd] > 0)
                {fClose_AllOrders (fs_Symbol, MG, ld_Pribul, li_cmd); return;}
                break;
            }
        }
    }
//----
    return;
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY                                                                  |
//+-----------------------------------------------------------------------------------+
//|             ""                                |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fMyPositions (double& fd_Profit,          //     
                  int& ar_MyOrders[][],       //      
                  string ar_Symbols[],        //    
                  int fi_Magic = -1)          // Magic
{
    int    li_total = OrdersTotal(), li_Ord = 0, li_ind_SMB;
    double ld_Profit;
//----
    //fMyPositions (gd_Profit, gia_MyOrders, gsa_SMB, MG);
    ArrayInitialize (ar_MyOrders, 0);
    fd_Profit = 0.0;
    if (li_total == 0) {return (0);}
    for (int li_pos = li_total - 1; li_pos >= 0; li_pos--)
    {
        if (!OrderSelect (li_pos, SELECT_BY_POS, MODE_TRADES)) continue;
        li_ind_SMB = fGet_INDInArraySTR (OrderSymbol(), ar_Symbols);
        if (li_ind_SMB < 0) continue;
        if (OrderMagicNumber() != fi_Magic && fi_Magic >= 0) continue;
        if (OrderType() > 1) continue;
        ld_Profit = OrderProfit() + OrderSwap() + OrderCommission();
        fd_Profit += ld_Profit;
        ar_MyOrders[li_ind_SMB][2]++;
        ar_MyOrders[li_ind_SMB][OrderType()]++;
        li_Ord++;
    }
//----
    return (li_Ord);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY                                                                  |
//+-----------------------------------------------------------------------------------+
//|          STRING  ,  sDelimiter                 |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fSplitStrToStr (string fs_List,             //   
                    string& ar_OUT[],           //  
                    string fs_Delimiter = ",")  //    
{
    string tmp_str = "", tmp_char = "";
//----
    ArrayResize (ar_OUT, 0);
    for (int i = 0; i < StringLen (fs_List); i++)
    {
        tmp_char = StringSubstr (fs_List, i, 1);
        if (tmp_char == fs_Delimiter)
        {
            if (StringTrimLeft (StringTrimRight (tmp_str)) != "")
            {
                ArrayResize (ar_OUT, ArraySize (ar_OUT) + 1);
                ar_OUT[ArraySize (ar_OUT) - 1] = tmp_str;
            }
            tmp_str = "";
        }
        else {if (tmp_char != " ") {tmp_str = tmp_str + tmp_char;}}
    }
    if (StringTrimLeft (StringTrimRight (tmp_str)) != "")
    {
        ArrayResize (ar_OUT, ArraySize (ar_OUT) + 1);
        ar_OUT[ArraySize (ar_OUT) - 1] = tmp_str;
    }
//----
    return (ArraySize (ar_OUT));
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+===================================================================================+
//|***********************************************************************************|
//| : MONEY MANAGEMENT                                                          |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY                                                                  |
//+-----------------------------------------------------------------------------------+
//|               (  )         |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fGet_SizeLot (double fd_Lot)
{
    //----  MM   - 
    if (!UseMM) {return (fLotsNormalize (fd_Lot));}
    double ld_Lots, Money = 0;
//----
    switch (MeansType)
    {
        case 1: Money = AccountBalance(); break;
        case 2: Money = AccountEquity(); break;
        case 3: Money = AccountFreeMargin(); break;
    }                
    switch (LotsWayChoice)
    {
        case 0: ld_Lots = fd_Lot; break;
        case 1: //    
            if (MeansType == 3)
            {ld_Lots = (Money * LotsPercent) / (MarketInfo (Symbol(), MODE_MARGINREQUIRED) * 100.0);}
            else {ld_Lots = Money * MathMin (AccountLeverage(), 100.0) * LotsPercent / (100000.0 * 100.0);}
            break;
    }
//----
    return (fLotsNormalize (ld_Lots));
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY                                                                  |
//+-----------------------------------------------------------------------------------+
//|                                                         |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
double fLotsNormalize (double fd_Lots)
{
//----
    fd_Lots -= gd_MINLOT;
    fd_Lots /= gd_LOTSTEP;
    fd_Lots = MathRound (fd_Lots);
    fd_Lots *= gd_LOTSTEP;
    fd_Lots += gd_MINLOT;
    if (fd_Lots < gd_MINLOT)
    {
        Print ("  (", DoubleToStr (fd_Lots, gi_dig), ")   (", DoubleToStr (gd_MINLOT, gi_dig), ").    .");
        fd_Lots = gd_MINLOT;
    }
    if (fd_Lots > gd_MAXLOT)
    {
        Print ("  (", DoubleToStr (fd_Lots, gi_dig), ")   (", DoubleToStr (gd_MAXLOT, gi_dig), ").    .");
        fd_Lots = gd_MAXLOT;
    }
    fd_Lots = MathMax (fd_Lots, MinLot);
    fd_Lots = MathMin (fd_Lots, MaxLot);
    fd_Lots = NormalizeDouble (fd_Lots, gi_dig);
//----
    return (fd_Lots);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+===================================================================================+
//|***********************************************************************************|
//| :                                                           |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|      : TarasBY                                                               |
//+-----------------------------------------------------------------------------------+
//|  UNI:                                       |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
int fGet_INDInArraySTR (string fs_Value, string ar_Array[])
{
//---- 
    for (int li_IND = 0; li_IND < ArraySize (ar_Array); li_IND++)
    {if (ar_Array[li_IND] == fs_Value) {return (li_IND);}}
//---- 
    return (-1);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//+===================================================================================+
//|***********************************************************************************|
//| : TESTER                                                                    |
//|***********************************************************************************|
//+===================================================================================+
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
//|   : TarasBY                                                                  |
//+-----------------------------------------------------------------------------------+
//|           ""                                   |
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+
bool fSet_Continue()
{
//----
    if (IsOptimization())
    {
        if (TrailProfit_ON)
        {
            if (!ValueInCurrency)
            {
                if (TrailProfit_StartPercent <= TrailProfit_LevelPercent) return (true);
                if (TakeProfit_ON) {if (TP_AdvisorPercent <= TrailProfit_StartPercent) return (true);}
            }
            else
            {
                if (TrailProfit_Start <= TrailProfit_Level) return (true);
                if (TakeProfit_ON) {if (TP_Advisor <= TrailProfit_Start) return (true);}
            }
        }
    }
//----
    return (false);
}
//IIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIIII+

